#ifndef GLUTILS_H
#define GLUTILS_H

/******************************** font stuff *********************************/

/* using a simple glCallLists fixed width font that's _way_ faster than
   glut's fonts on nvidia, at least */
void DrawString( int fontSize, float x, float y, char *string );             // screen space string
void DrawStringOrthoPixels( int fontSize, float x, float y, char *string );  // don't set matrix, assume PushOrthoPixels()
float GetTextHeight( int fontSize );
float GetTextWidth( int fontSize, char *string );
int unsigned GetFontBase( void );       // if you want to draw it yourself


/**************************** misc drawing stuff *****************************/

void DrawTimingBars( void );        // groovy fps counter with hysteresis
void PushOrthoPixels( void );
void PopOrthoPixels( void );
int unsigned gl_texture_from_bitmap(unsigned char *bits, int width, int height,
                                    int bytes_per_pixel);


#endif // GLUTILS_H
