#include "Cfg.h"

#include "SysAssert.h"
#include "SysMalloc.h"
#include "Elipsis.h"
#include "StaticString.h"

#include "Interpreter.h"


#define MAXLEN  (1024*32)

void Cfg::_set( char *newValue )
{
	if( *newValue == '{' )
	{
		interpret( newValue );
		return;
	}

	char temp[MAXLEN];
	temp[0] = '\0';
	defaultInterpreter.get( newValue, temp );
	sysHeapChk();
	Str::_set( temp );
	sysHeapChk();
}

char *Cfg::interpret( char *srcString )
{
	char result[MAXLEN];
	defaultInterpreter.interpret( MAXLEN, result, srcString, 0 );
	sysHeapChk();
	Str::_set( result );
	sysHeapChk();
	return s;
}

char *Cfg::spare()
{
	return staticString( s );
}