//
// Include files
//

#include "Esc.h"
#include "string.h"
#include "Elipsis.h"
#include "ctype.h"
#include "stdlib.h"

//
// Routines
//

TempStr::TempStr( char *fmt, ... )
{
	elipsisTo(TEMPSTR_LEN,s,fmt);
}

void TempStr::set( char *fmt, ... )
{
	elipsisTo(TEMPSTR_LEN,s,fmt);
}

void TempStr::append( char *fmt, ... )
{
	int length = strlen(s);
	int limit = TEMPSTR_LEN-(length+1);
	char *ptr = s + length;
	#pragma warning(disable:4018)		// warning C4018: '<' : signed/unsigned mismatch
	elipsisTo(limit,ptr,fmt);
	#pragma warning(default:4018)
}

int TempStr::getLength()
{
	return strlen(s);
}

char *TempStr::allCaps()
{
	char *ss = s;
	while( *ss )
	{
		*ss = toupper(*ss);
		++ss;
	}
	return s;
}

char *TempStr::cap()
{
	char *ss = s;
	while( *ss && !isalpha(*ss) )
	{
		++ss;
	}

	if( *ss )
	{
		*ss = toupper(*ss);
	}
	return s;
}

int TempStr::getInt()
{
	return atoi( s );
}
