#ifndef INTERPRETER_H
#define INTERPRETER_H


typedef char *GetKeywordFn ( char *keyword, char *result );
typedef char *SetKeywordFn ( char *keyword, char *result );
typedef char *InterpretFn  ( int maxLen, char *result, char *src, ... );

class Interpreter
{
public:
	GetKeywordFn *get;
	SetKeywordFn *set;
	InterpretFn  *interpret;

public:
	Interpreter();
	void init( 
		GetKeywordFn *get,
		SetKeywordFn *set,
		InterpretFn  *interpret
	);
};


extern Interpreter defaultInterpreter;

#endif

