#ifndef STREXTRA_H
#define STREXTRA_H

extern char *stristr( char *src, char *findMe );
	// Returns ptr to first case-insensitive occurence of findMe in src.

extern char *strzcpy( char *dest, char *src, int len );
	// This is a strncpy that appends a \0.  len should be one 
	// character shorter that the max length of dest.

extern int   strzcmp( char *main, char *subStr );
	// Does a strnicmp on main to the length of subStr.

extern char *strcpyUntil( char *dest, char *src, char *stoppers );
	// Copies from src to dest until *src is in stoppers.
	// Returns which member of stoppers it stopped on, or \0.

extern char *strzcpyUntil( char *dest, char *src, int maxLen, char *stoppers );
	// Copies from src to dest until *src is in stoppers, or when
	// maxLen characters have been copied.  terminates with /0
	// Returns which member of stoppers it stopped on, or \0.

extern char *strzcpyUntilChar( char *dest, char *src, int maxLen, char stopper );
	// Copies until maxLen is reached, or *src==stopper.  Terminates w/0
	// Returns stopper if that is what it stopped on, or \0.

extern int strMatchWild( char *srcWild, char *other );
	// Allows comparison of ( "mystr*", "mystringhappy" ) to be true.
	// The asterix is the only wildcard supported.

extern void strReplace( char *s, char a, char b );
	// changes all instances of a in s to b

extern void strReplacePairs( char *s, char *c );
	// Replaces c[0] with c[1], then c+=2 until the end of c

	
extern char *strSkip( char *src, char *skipUs );

extern char *strcpyCap( char *dest, char *src );

extern char *strAdvanceUntil( char *s, char *findOneOf );
extern char *strRetreatUntil( char *s, char *start, char *findMe );

extern char *strSkipWhite( char *src );
extern char *strTrim( char *src, char *trimList );
extern char *strTrimWhite( char *src );

extern char *strGet  ( char *list, int index, char indexSeparator );
extern int   strCount( char *list, char indexSeparator );
extern int   strFind ( char *what, char *list, char indexSeparator );
	// Returns the index of the object it found, or -1 if not found.

inline int strIs( char c, char *s )
{
	while( *s )
	{
		if( *s == c )
		{
			return 1;
		}
		++s;
	}
	return 0;
}

inline char *strAdvanceUntilChar( char *s, char findMe )
{
	while( *s && *s != findMe )
	{
		++s;
	}
	return s;
}

inline char *strRetreatUntilChar( char *s, char *start, char findMe )
{
	while( s != start && *s != findMe )
	{
		--s;
	}
	return s;
}


inline char *strAdvancePastChar( char *s, char findMe )
{
	while( *s == findMe )
	{
		++s;
	}
	return s;
}


#endif

