#include "string.h"
#include "ctype.h"	

char *strSeekNextLine( char *s )
{
	while( *s && *s!='\n' )
	{
		++s;
	}
	while( *s=='\n' || *s=='\r' || *s==' ' || *s=='\t' )
	{
		++s;
	}
	return s;
}

char *strSeek( char assignmentOperator, char prefixSeparator, char *keyword, char *data )
{
	if( !data )
	{
		return 0;
	}

	char *s = data;
	int len = strlen( keyword );
	char firstLetter = toupper(*keyword);

	while( *s )
	{
		while( *s && (*s==' ' || *s=='\t' ) )
		{
			++s;
		}
		if( (toupper(*s)==firstLetter) && (strnicmp(s,keyword,len)==0) )
		{
			char *temp = s + len;
			while( *temp && (*temp==' ' || *temp=='\t') )
			{
				++temp;
			}
			if( *temp == assignmentOperator || *temp == prefixSeparator )
			{
				break;
			}
		}
		s = strSeekNextLine(s);
	}

	if( !*s )
	{
		s = 0;
	}

	return s;
}

char *strSeekNextSection( char startSection, char endSection, char *s, char *section, char *sectionName = 0 )
{
	int len = strlen( section );

	while( *s )
	{
		while( *s && (*s==' ' || *s=='\t' ) )
		{
			++s;
		}
		while( *s == startSection )
		{
			if( strnicmp(s,section,len)==0 )
			{
				char *start = s;
				if( sectionName )
				{
					++s;
					while( *s != endSection )
					{
						*sectionName = *s;
						++sectionName;
						++s;
					}
					*sectionName = '\0';
				}

				return start;
			}
			else
			{
				++s;
				while( *s && *s != '\n' && *s != startSection )
				{
					++s;
				}
			}
		}
		s = strSeekNextLine(s);
	}
	return s;
}

char *strSeekSection( char startSection, char endSection,  char *section, char *data )
{
	if( !data )
	{
		return 0;
	}

	char *s = data;
	s = strSeekNextSection( startSection, endSection, s, section );

	if( !*s )
	{
		s = 0;
	}

	return s;
}

