#include "FileTime.h"

#include "windows.h"

FileTime fileTimeElapsed( FileTime *start, FileTime *end )
{
	FileTime f;
	if( start->lo > end->lo )
	{
		// For example:
		//     101 : 20  end
		//   - 100 : 40	 start
		//   = 000 : 80	 (or 100-(40-20)
		unsigned long int top = 0xFFFFFFFF;
		f.hi = (end->hi - start->hi) - 1;
		f.lo = top - (start->lo - end->lo - 1 );
	}
	else
	{
		f.hi = end->hi - start->hi;
		f.lo = end->lo - start->lo;
	}
	return f;
}

unsigned long int fileTimeGetSeconds( FileTime *ft )
{
	unsigned long int hiMod = 0xFFFFFFFF / (10*1000*1000);

	return (ft->hi*hiMod) + (ft->lo / (10*1000*1000));
}


void fileTimeAddSeconds( FileTime *ft, unsigned long int secs )
{
	// I could do crazy conversions to LARGE_INTEGER but why
	// start including more windows code than I must? -Ken
	unsigned long int top = 0xFFFFFFFF;
	unsigned long int diff = top - ft->lo;
	secs = secs * 10 * 1000 * 1000;
	if( secs <= diff )
	{
		ft->lo += secs;
	}
	else
	{
		++ft->hi;
		ft->lo = secs - diff - 1;
	}
} 


void fileTimeGetLocal( FileTime *ft )
{
	SYSTEMTIME winSystemTime;
	FILETIME   winFileTime;

	GetLocalTime( &winSystemTime );
	SystemTimeToFileTime( &winSystemTime, &winFileTime );

	ft->hi = winFileTime.dwHighDateTime;
	ft->lo = winFileTime.dwLowDateTime;
}

void fileTimeGetUTC( FileTime *ft )
{
	SYSTEMTIME winSystemTime;
	FILETIME   winFileTime;

	GetSystemTime( &winSystemTime );
	SystemTimeToFileTime( &winSystemTime, &winFileTime );

	ft->hi = winFileTime.dwHighDateTime;
	ft->lo = winFileTime.dwLowDateTime;
}

int fileTimeLaterThan( FileTime *isThisLater, FileTime *thanThis )
{
	if( isThisLater->hi > thanThis->hi )
	{
		return 1;
	}
	if( isThisLater->hi == thanThis->hi )
	{
		return( isThisLater->lo > thanThis->lo );
	}
	return 0;
}

