#ifndef FILETIME_H
#define FILETIME_H

#ifdef __cplusplus
extern "C" {
#endif

// This structure mirrors Window's FILETIME structure, which
// always uses UTC to do its thing.
typedef struct FileTime {
	unsigned long int lo; 
	unsigned long int hi; 
} FileTime;

extern void     fileTimeGetUTC( FileTime *ft );
extern void     fileTimeGetLocal( FileTime *ft );
extern FileTime fileTimeElapsed( FileTime *start, FileTime *end );

extern unsigned long int fileTimeGetSeconds( FileTime *ft );
extern void     fileTimeAddSeconds( FileTime *ft, unsigned long int secs );
extern int      fileTimeLaterThan( FileTime *isThisLater, FileTime *thanThis );

#ifdef __cplusplus
}
#endif

#endif


/*
	Sadly, this thing's .c file includes windows.h in order to get
	the current time with fileTimeGetUTC.  However, there might be
	some useful way to split that out of here.
*/

