#include "SysAssert.h"
#include "assert.h"
	   
// See sysAssert.h for details.

int globalInAssert = 0;

extern void sysAssertDefault(void *, void *, unsigned);
SysAssertCallbackFn *sysAssertCallback = &sysAssertDefault;


SysAssertCallbackFn *sysAssertSetCallback( SysAssertCallbackFn *newAssertCallback )
{
	SysAssertCallbackFn *oldCallback = sysAssertCallback;
	sysAssertCallback = newAssertCallback;
	return oldCallback;
}

void sysAssertDefault( void *exp, void *file, unsigned line )
{
	#ifdef _DEBUG
		_assert( exp, file, line );	
	#endif
}


// This might seem a little redundant, but I needed a unique name
// for the place that all sysAsserts would begin.  From here, I
// call the sysAssertCallback routine, whatever it has been 
// assigned to be. -Ken
void sysAssertEntryPoint( void *exp, void *file, unsigned line )
{
	if( globalInAssert )
		return;
	globalInAssert = 1;
	sysAssertCallback( exp, file, line );
	globalInAssert = 0;
}




							 