#ifndef SYSASSERT_H
#define SysASSERT_H

#ifdef __cplusplus
extern "C" {
#endif

// You should use sysAssert() anywhere that
// you would normally use assert().
//
// If you wish to be called back when asserts hsysen, use the
// routine sysAssertSetCallback().  It returns the address of
// the callback routine that you're replacing.

#undef  assert
#define assert PleaseUseSysAssertInsteadOfassert.

// This is the prototype
typedef void SysAssertCallbackFn( void *exp, void *file, unsigned line );

extern SysAssertCallbackFn *sysAssertSetCallback( SysAssertCallbackFn *newAssertCallback );


extern void sysAssertEntryPoint( void *, void *, unsigned );

#define sysAssert(exp) (void)( (exp) || (sysAssertEntryPoint(#exp, __FILE__, __LINE__), 0) )

#ifdef __cplusplus
}
#endif


#define warn sysAssert

#endif

