#include "SysAssert.h"
#include "string.h"


char *stdSeparators = " \t\n,\xa0\x96";

char *sysParse( int maxLen, char *dest, char *s, char *separatorList, int allowSingleQuote, int passSeparators, char quote )
{
	sysAssert( (s) && (s!=(char*)0xcccccccc) );

	if( !separatorList )
		separatorList = stdSeparators;
	// skip preceding white space.
	char *destStart = dest;
	while( *s && ( *s==' ' || *s=='\t' || *s == -96 ) )
		++s;
	int reps = maxLen-1;
	char inLiteral = '\0';

	if( quote == '\0' )
		quote = '\"';

	// 26-Sep-2003 Ken made it so this will automatically think
	// any character outside the range of 0..127 is a separator.
	//
	// 29-Oct-2003 Ken decided to make only chars -96 and -106 separators.

	while( *s && reps-- && (inLiteral || ( (strchr(separatorList,*s)==0) && *s != -96 && *s != -106 ) ) )
	{
		if( !inLiteral && ( *s == quote || (allowSingleQuote && *s=='\'' ) ) )
		{
			// If we've already gotten character(s) outside the quotes
			// then we should take this quote to mean an end-quote.
			if( dest > destStart )
				break;
			inLiteral = *s;
		}
		else
		if( inLiteral && *s == inLiteral )
		{
			inLiteral = '\0';
		}
		else
		{
// This is weird. I don't know what I was doing. Got rid of it because bounds checker complained. -Ken
//			assert( dest - s );
			*(dest++) = *s;
		}
		++s;
	}

	// Pass any separators you might have found.
	if( passSeparators )
		while( *s && ( strchr(separatorList,*s) || *s == -96 || *s == -106) )
			++s;

	if( dest!=destStart )
		{
		--dest;
		while( dest!=destStart )
			{
			if( *dest==' ' || *dest=='\t' || *dest == -96 || *dest == -106 )
				--dest;
			else
				break;
			}

		++dest;
		}
	*dest = '\0';
	return s;
}

