#ifndef CEXTERNS_H
#define CEXTERNS_H

#include "stdlib.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef void * CcCallocFn  ( size_t num, size_t size );
typedef void * CcMallocFn  ( size_t size );
typedef void * CcReallocFn ( void *memblock, size_t size );
typedef void   CcFreeFn    ( void *memblock );
typedef int    CcHeapChkFn ( void );
typedef void   CcHeapDumpFn( void );

extern CcCallocFn *		ccCalloc;
extern CcMallocFn *		ccMalloc;
extern CcReallocFn *	ccRealloc;
extern CcFreeFn *		ccFree;
extern CcHeapChkFn *	ccHeapChk;
extern CcHeapDumpFn *	ccHeapDump;


#ifdef __cplusplus
}
#endif

#endif

