#include "FastRandom.h"
#include "stdlib.h"
#include "math.h"
#include "time.h"				// For the random routines.

////////////////////////////////////////////////////////////////////////////////////////////////
// Fast Random Numbers
////////////////////////////////////////////////////////////////////////////////////////////////
int lastRandomNumber = 55;

extern void fastRandomize();


// Ken says, "I've tested this formula with the seed 0x0bad0bad and it produces a string of
// at least one hundred thousand unique random numbers."
#define getRand(n,a) \
	if( !n ) \
		n = 0x0bad0bad; \
	n = (n*65539+3); \
	a = (unsigned short int)(n>>16)


int fastRandomInt( int maxInt )
{
	unsigned int a;
	getRand(lastRandomNumber,a);
	return a%maxInt;
}

float fastRandomFloat( float maxFloat )
{
	unsigned int a;
	getRand(lastRandomNumber,a);
	{
		float b = (float)a;
		b /= (float)65536.0;
		b *= (float)fabs(maxFloat);
		return b;
	}
}

void fastRandomize( int seedRandWithTime )
{
	int i;

	if( seedRandWithTime )
	{
		srand((unsigned)time(NULL));
	}
	else
	{
		srand(3724597);	
	}

	for( i=0; i<10; i++ )
	{
		rand();
	}
	lastRandomNumber = rand() * rand() * rand();
}

void fastRandomPushSeed( int *storedSeed, int newSeed )
{
	*storedSeed = lastRandomNumber;
	lastRandomNumber = newSeed;
}

void fastRandomPopSeed( int storedSeed )
{
	lastRandomNumber = storedSeed;
}



float fastRandomGetBell( float a, float b )
{
	b = (b-a) / 3.0f;
	return a+(fastRandomFloat(b)+fastRandomFloat(b)+fastRandomFloat(b));
}

float fastRandomGetPyramid( float a, float b )
{
	b = (b-a) / (float)2.0;
	return a+(fastRandomFloat(b)+fastRandomFloat(b));
}

