#ifndef TIMESTR_H
#define TIMESTR_H

#ifdef __cplusplus
extern "C" {
#endif
	struct UniversalTime;
	struct FileTime;
#ifdef __cplusplus
}
#endif

class TimeStr
{
	char str[80];
public:
	UniversalTime *u;

	~TimeStr();
	TimeStr();						// Initializes it with current time, UTC.
	TimeStr( UniversalTime *_u );
	TimeStr( FileTime *fTime );
	TimeStr( struct tm *tmTime );
	TimeStr( char *httpTime );

	TimeStr &getLocal();			// Initializes it with the local time.
	void set( TimeStr &t );
	void setElapsed( char *elapsedTime );

	// get() returns the last other get() called, or sets the
	// string to 15-Nov-94 15:45:12
	char *get();					

	char *getSortable();			// YYYY-MM-DD-HH-MM-SS
	char *getHttp();				// Tue, 15 Nov 1994 12:45:26 GMT
	char *getHttpShort();			// 15 Nov 1994 12:45:26
	char *getElapsed();				// HH:MM:SS.LLL    (hours, minutes, seconds, milliseconds)
	char *getSqlTime();				// YYYY-MM-DD HH:MM:SS
	char *getAsNumber();			// YYYYMMDDHHMMSS

	char *getDate();				// 15-Nov-1994
	char *getSortableDate();		// YYYY-MM-DD
	char *getTime();				// 12:23

	int   getElapsedInt();

	TimeStr & operator = (TimeStr &t);
};


#endif

